load -ascii wrench/elements.mat
load -ascii wrench/nodes.mat
load -ascii wrench/surface.mat
load -ascii wrench/spline2.mat

for j=(1:1:3)
[elements,nodes,surface,spline2] = refine_mesh(elements,nodes,surface,spline2); 
end
disp(sprintf('number of elements: %i',size(elements,1)));
disp(sprintf('number of nodes   : %i',size(nodes,1)));

trisurf(elements,nodes(:,1),nodes(:,2),zeros(size(nodes,1),1),rand(size(elements,1),1),'EdgeColor','none', 'CDataMapping', 'scaled')
view(0,90)
colormap(jet(512))
colorbar('vert')
%triplot(elements,nodes(:,1),nodes(:,2))
axis equal
axis tight
grid off

save -ascii wrench_fine/elements.mat elements
save -ascii wrench_fine/nodes.mat nodes
save -ascii wrench_fine/surface.mat surface
save -ascii wrench_fine/spline2.mat spline2

