function [e_new,n_new,surf_new,spl2_new] = refine_mesh_slow(e_old,n_old,surf_old,spl2_old)

e_new = zeros(0,3);
n_new = n_old;
nconnect = sparse(size(n_old,1),size(n_old,1));
surf_new = zeros(size(surf_old,1)*2,1);
spl2_new = zeros(size(spl2_old,1)*2,1);

for j=(1:1:size(e_old,1))
	
	a = e_old(j,1);
	b = e_old(j,2);
	c = e_old(j,3);
	
	ab = nconnect(max(a,b),min(a,b));
	bc = nconnect(max(b,c),min(b,c));
	ca = nconnect(max(c,a),min(c,a));
	
	if (ab == 0)
		n_new = [n_new; (n_old(a,1) + n_old(b,1))/2, (n_old(a,2) + n_old(b,2))/2];
		ab = size(n_new,1);
		nconnect(max(a,b),min(a,b)) = ab;
	end
	if (bc == 0)
		n_new = [n_new; (n_old(b,1) + n_old(c,1))/2, (n_old(b,2) + n_old(c,2))/2];
		bc = size(n_new,1);
		nconnect(max(b,c),min(b,c)) = bc;
	end
	if (ca == 0)
		n_new = [n_new; (n_old(c,1) + n_old(a,1))/2, (n_old(c,2) + n_old(a,2))/2];
		ca = size(n_new,1);
		nconnect(max(c,a),min(c,a)) = ca;
	end

	e_new = [e_new;
			 ab, bc, ca;
			 a, ab, ca;
			 b, bc, ab;
			 c, ca, bc];
end

a = n_new(surf_old(spl2_old(:,1),1),:);
b = n_new(surf_old(spl2_old(:,1),2),:);
c = n_new(surf_old(spl2_old(:,2),2),:);
n_new(surf_old(spl2_old(:,1),2),:) = ((a+c)./2 + b)./2;

for j=(1:1:size(surf_old,1))
	a = surf_old(j,1);
	b = surf_old(j,2);
	c = nconnect(max(a,b),min(a,b));
	surf_new(2*j-1, 1) = a;
	surf_new(2*j-1, 2) = c;
	surf_new(2*j,   1) = c;
	surf_new(2*j,   2) = b;
end

for j=(1:1:size(spl2_old,1))
	s1 = spl2_old(j,1);
	s2 = spl2_old(j,2);
	spl2_new(j*2-1, 1) = s1*2-1;
	spl2_new(j*2-1, 2) = s1*2;
	spl2_new(j*2,   1) = s2*2-1;
	spl2_new(j*2,   2) = s2*2;
end

